package com.iosoftware.ld22lma;

public class GCThread extends Thread {
	private int time;
	private static GCThread inst;
	private boolean running;
	private static final Object lock = new Object();

	public static void startGCThread() {
		startGCThread(5000);
	}

	public static void startGCThread(int time) {
		synchronized(lock) {
			if (inst == null) {
				inst = new GCThread(time);
			}
		}
	}
	
	public static void stopGCThread() {
		synchronized (lock) {
			if(inst != null) {
				inst.running = false;
				inst = null;
			}
		}
	}

	private GCThread(int time) {
		this.time = time;
		running = true;
		setName("GC Thread");
		setDaemon(true);
		start();
	}

	public void run() {
		while (true) {
			synchronized (lock) {
				if(!running) {
					break;
				}
			}
			Runtime.getRuntime().gc();
			Misc.sleep(time);
		}
	}
}
