package com.iosoftware.ld22lma;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import java.util.*;

public class LeafMeAlone {
	// sounds
	private SoundManager.Sound[] sounds;
	private SoundManager.Loop music;
	private static final int NUMSOUNDS = 18;
	private static final int SOUND_START = 0;
	private static final int SOUND_COLA = 1;
	private static final int SOUND_DESTROYED = 2;
	private static final int SOUND_DIE = 3;
	private static final int SOUND_FLATSCH = 4;
	private static final int SOUND_KLIRR = 5;
	private static final int SOUND_THROW = 6;
	private static final int SOUND_SOW = 7;
	private static final int SOUND_RIPE = 8;
	private static final int SOUND_OMNOM = 9;
	private static final int SOUND_HITGROUND = 10;
	private static final int SOUND_HITPLANT = 11;
	private static final int SOUND_HITSELF = 12;
	private static final int SOUND_HITMARKER = 13;
	private static final int SOUND_UPROOT = 14;
	private static final int SOUND_DONE = 15;
	private static final int SOUND_HEART = 16;
	private static final int SOUND_MUSIC = 17;
	private static final String[] soundNames = { "start", "cola", "destroyed",
			"die", "flatsch", "klirr", "throw", "sow", "ripe", "omnom",
			"hitground", "hitplant", "hitself", "hitmarker", "uproot", "done",
			"heart", "music" };
	private JFrame window;
	private Drawscreen ds;
	private Image[] projectiles, handimgs, ground, legs, kidimgs;
	private Image icon, logo, uiimg, mapimg, gardener, gardenerStunned, ready,
			wonimg;
	private int lastLevel = 5; // before this level, the "you won" screen will
								// be displayed
	private int level, heart, fadeType, fade, flash, hand, offhand, care, time,
			timeNeeded, kills, killsNeeded, tomatoesNeeded, protect, thrown,
			planted, destroyed, damageTaken, cola, stunned, health, uproot,
			sow, pickupIn, cooldownAll, maxKids, kidSpawnTime, kidSpawnTimeMin,
			kidSpawnTimeRandom, healed, score;
	private double walked, rotation;
	private int[] cooldown;
	private static final int MAXCDALL = 75;
	private boolean[][] walk;
	private boolean[] keys, keys2, allowed;
	private boolean paused, ingame, gameover, won, successinfo, loaded,
			playMusic, playSound;
	private Font fontLevel, fontQuote, fontText, fontStats;
	private Point mouse;
	private Vector2D pos;
	private java.util.List<GameObj> objs;
	private java.util.List<Kid> kids;
	private Plant[][] plants;
	private static final Color PAUSEBG = new Color(255, 255, 255, 200),
			CDCOLOR = new Color(127, 127, 127, 200), POISONCOLOR = new Color(0,
					200, 0, 127), HITCOLOR = new Color(200, 0, 0, 127);
	private static final String[] names = { "A regular day",
			"It gets annoying", "Counter Measures", "The constant gardener",
			"Final Stand", "Endless Survival" };
	private static final String[] quotes = { "\"The life of a gardener...\"",
			"\"No school today?\"", "\"I hate todays youth...\"",
			"\"I feel sooo alone now...\"", "\"Alright then...\"",
			"\"Just a bad dream...\"" };
	private static final String[] desc = { "Protect at least 4 flowers",
			"Protect at least 5 flowers", "Plant 5 tomatoes",
			"Fend off 25 kids", "Protect at least 5 flowers",
			"Protect at least 4 flowers" };
	private static final String[] desc2 = { "Survive 1 minute",
			"Fend off 5 kids", "Fend off 10 kids", "Survive 3 minutes",
			"Survive 5 minutes", "Survive forever!" };
	private static final String[] desc3 = {
			"(Tip: P pauses the game and displays a help screen!)",
			"Survive 2 minutes",
			"(Tip: The size of an object tells you where it will land.)",
			"(Tip: Make screenshots with F2 (saved in C:/LMASS/))", "(Tip: Use F3 and F4 to mute music/sound!)",
			"(Tip: To instantly win a level press CTRL+F5!)" };
	private LeafMeAlone inst;

	public static void main(String[] args) {
		new LeafMeAlone();
	}

	private LeafMeAlone() {
		inst = this;
		GCThread.startGCThread();
		init();
		loadImportant();
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				initSwing();
			}
		});
		Misc.sleep(1000); // fake loadtime xD
		load();
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				startSwing();
			}
		});
	}

	private void resetKeys() {
		for (int i = 0; i < keys.length; i++) {
			keys[i] = false;
			keys2[i] = false;
		}
	}

	private static int getKey(int kc) {
		switch (kc) {
		case KeyEvent.VK_W:
			return 0;
		case KeyEvent.VK_A:
			return 1;
		case KeyEvent.VK_S:
			return 2;
		case KeyEvent.VK_D:
			return 3;
		case KeyEvent.VK_1:
			return 4;
		case KeyEvent.VK_2:
			return 5;
		case KeyEvent.VK_3:
			return 6;
		case KeyEvent.VK_4:
			return 7;
		case KeyEvent.VK_5:
			return 8;
		case KeyEvent.VK_NUMPAD0:
			return 9;
		case KeyEvent.VK_P:
			return 10;
		case KeyEvent.VK_F2:
			return 11;
		case KeyEvent.VK_UP:
			return 12;
		case KeyEvent.VK_LEFT:
			return 13;
		case KeyEvent.VK_DOWN:
			return 14;
		case KeyEvent.VK_RIGHT:
			return 15;
		case KeyEvent.VK_E:
			return 18;
		case KeyEvent.VK_F5:
			return 19;
		case KeyEvent.VK_NUMPAD1:
			return 20;
		case KeyEvent.VK_NUMPAD2:
			return 21;
		case KeyEvent.VK_NUMPAD3:
			return 22;
		case KeyEvent.VK_NUMPAD4:
			return 23;
		case KeyEvent.VK_NUMPAD5:
			return 24;
		case KeyEvent.VK_SPACE:
			return 25;
		case KeyEvent.VK_F3:
			return 26;
		case KeyEvent.VK_F4:
			return 27;
		default:
			return -1;
		}
	}

	private void startSwing() {
		fadeType = 5;
		fade = 1;
	}

	private void play(int sound) {
		if (playSound) {
			sounds[sound].play();
		}
	}

	private void init() {
		playMusic = true;
		playSound = true;
		loaded = false;
		allowed = new boolean[5];
		cooldown = new int[allowed.length];
		keys = new boolean[28];
		keys2 = new boolean[keys.length];
		resetKeys();
		successinfo = false;
		flash = 0;
		level = -1;
		paused = false;
		ingame = false;
		mouse = new Point(0, 0);
		kids = new ArrayList<Kid>();
		objs = new ArrayList<GameObj>();
		plants = new Plant[12][8];
		walk = new boolean[12][8];
		for (int x = 0; x < 12; x++) {
			for (int y = 0; y < 8; y++) {
				walk[x][y] = !(y < 2 || x == 11 || y == 7 || (x > 8 && y > 4));
			}
		}
	}

	// important stuff
	private void loadImportant() {
		icon = Misc.loadImage("/res/icon.png");
		try {
			Font fontBase = Font.createFont(Font.TRUETYPE_FONT,
					Misc.class.getResourceAsStream("/res/verdana.ttf"));
			fontLevel = fontBase.deriveFont(Font.BOLD, 40);
			fontQuote = fontBase.deriveFont(Font.ITALIC, 30);
			fontText = fontBase.deriveFont(Font.PLAIN, 20);
			fontStats = fontBase.deriveFont(Font.PLAIN, 16);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	// stuff that can wait
	private void load() {
		logo = Misc.loadImage("/res/logo.png");
		uiimg = Misc.loadImage("/res/ui.png");
		mapimg = Misc.loadImage("/res/map.png");
		gardener = Misc.loadImage("/res/gardener.png");
		ready = Misc.loadImage("/res/ready.png");
		gardenerStunned = Misc.loadImage("/res/gardener_stunned.png");
		ready = Misc.loadImage("/res/ready.png");
		wonimg = Misc.loadImage("/res/won.png");
		projectiles = Misc.loadImages("/res/projectiles.png", 7, 1);
		handimgs = Misc.loadImages("/res/hand.png", 5, 2);
		ground = Misc.loadImages("/res/ground.png", 7, 2);
		legs = Misc.loadImages("/res/legs.png", 4, 1);
		kidimgs = Misc.loadImages("/res/kids.png", 6, 1);
		sounds = new SoundManager.Sound[NUMSOUNDS];
		for (int i = 0; i < NUMSOUNDS; i++) {
			sounds[i] = SoundManager.load("/res/sounds/" + soundNames[i]
					+ ".wav");
		}
		music = SoundManager.createLoop(sounds[SOUND_MUSIC]);
		if (playMusic) {
			music.startLoop();
		}
	}

	private Color getHealthColor(double has, double max) {
		int health = (int) (10d * has / max);
		switch (health) {
		case 0:
		case 1:
		case 2:
			return Color.RED;
		case 3:
		case 4:
		case 5:
			return Color.ORANGE;
		case 6:
		case 7:
			return Color.YELLOW;
		case 8:
		case 9:
		case 10:
			return Color.GREEN;
		default:
			return Color.GRAY;
		}
	}

	private boolean canGo(double x, double y) {
		if (x - 25d >= 0 && y - 25d >= 0 && x + 25d < 600d && y + 25d < 400d) {
			int x1 = (int) ((x - 25d) / 50d);
			int y1 = (int) ((y - 25d) / 50d);
			int x2 = (int) ((x + 25d) / 50d);
			int y2 = (int) ((y - 25d) / 50d);
			int x3 = (int) ((x - 25d) / 50d);
			int y3 = (int) ((y + 25d) / 50d);
			int x4 = (int) ((x + 25d) / 50d);
			int y4 = (int) ((y + 25d) / 50d);
			return (walk[x1][y1] && walk[x2][y2] && walk[x3][y3] && walk[x4][y4]);
		}
		return false;
	}

	private int getSeed() {
		if (keys[4] || keys[20]) {
			return 5;
		} else if (keys[5] || keys[21]) {
			return 6;
		} else if (keys[6] || keys[22]) {
			return 7;
		} else if (keys[7] || keys[23]) {
			return 8;
		} else if (keys[8] || keys[24]) {
			return 9;
		}
		return -1;
	}

	private static String formatTime(int time) {
		int s = time / 25;
		int m = s / 60;
		s -= m * 60;
		int h = m / 60;
		m -= h * 60;
		return "" + (h > 0 ? h + ":" : "") + (m < 10 && h > 0 ? "0" : "") + m
				+ ":" + (s < 10 ? "0" : "") + s;
	}

	private static String formatDistance(double dis) {
		return "" + (Math.round(dis / 5d) / 10d) + " m";
	}

	private int plantCount(PlantType type) {
		int c = 0;
		Plant p;
		for (int x = 0; x < 12; x++) {
			for (int y = 0; y < 8; y++) {
				p = plants[x][y];
				if (p != null) {
					if (p.type == type && p.grow == 0) {
						c++;
					}
				}
			}
		}
		return c;
	}

	public void damage(int dmg, boolean stun) {
		play(SOUND_HITSELF);
		damageTaken += dmg;
		health -= dmg;
		if (health <= 0) {
			health = 0;
		}
		if (health == 0 || stun) {
			stunned = 3 * 25;
		}
	}

	private boolean hasGoals() {
		boolean goalTime = (timeNeeded <= 0 || timeNeeded <= time);
		boolean goalProtect = (protect <= 0 || protect <= plantCount(PlantType.FLOWER));
		boolean goalKills = (killsNeeded <= 0 || killsNeeded <= kills);
		boolean goalTomatoes = (tomatoesNeeded < 0 || tomatoesNeeded <= plantCount(PlantType.TOMATOE));
		boolean noGoals = timeNeeded <= 0 && killsNeeded <= 0
				&& tomatoesNeeded <= 0;
		return !noGoals && goalTime && goalProtect && goalKills && goalTomatoes;
	}

	private void tick() {
		if (fade == 0 && keys[25]) {
			if (level >= 0) {
				if (!ingame) {
					keys[25] = false;
					if (gameover) { // stats screen -> newlevel
						fadeType = 1;
						fade = 1;
					} else {
						if (level == lastLevel && !successinfo) { // newlevel(+successinfo)
																	// ->
																	// newlevel
							fade = 1;
							fadeType = 4;
						} else { // newlevel -> start level
							fade = 1;
							fadeType = 2;
							play(SOUND_START);
						}
					}
				}
			} else if (loaded) {
				fade = 1;
				fadeType = 1;
			}
		}
		if (!paused) {
			flash++;
			if (flash >= 25) {
				flash = -25;
			}
			if (fade < 0) {
				fade++;
			} else if (fade > 0) {
				fade++;
				if (fade == 17) {
					fade = -17;
					switch (fadeType) {
					case 1: // newlevel
						if (level != 5) {
							level++;
						}
						initLevel();
						break;
					case 2: // ingame
						ingame = true;
						break;
					case 3: // stats / level again
						ingame = false;
						if (won) {
							score = calculateScore();
						} else {
							fadeType = 1;
							initLevel();
						}
						break;
					case 4: // successinfo
						successinfo = true;
						break;
					case 5: // loaded
						loaded = true;
						break;
					}
				}
			}
			if (ingame) {
				time++;
				if (cola > 0) {
					cola--;
				}
				if (cooldownAll > 0) {
					cooldownAll--;
				}
				heart--;
				if (heart <= 0) {
					if (health <= 4) {
						play(SOUND_HEART);
					}
					heart = health <= 2 ? 12 : 25;
				}
				{
					Plant p;
					for (int x = 0; x < 12; x++) {
						for (int y = 0; y < 8; y++) {
							p = plants[x][y];
							if (p != null) {
								p.tick();
							}
						}
					}
				}
				{
					GameObj o;
					for (int i = 0; i < objs.size(); i++) {
						o = objs.get(i);
						if (!o.exists()) {
							objs.remove(i);
							i--;
							continue;
						}
						o.tick();
						if (!o.exists()) {
							objs.remove(i);
							i--;
							continue;
						}
					}
				}
				{
					Kid k;
					for (int i = 0; i < kids.size(); i++) {
						k = kids.get(i);
						if (!k.exists()) {
							kids.remove(i);
							i--;
							continue;
						}
						k.tick();
						if (!k.exists()) {
							kids.remove(i);
							i--;
							continue;
						}
					}
				}
				for (int i = 0; i < 5; i++) {
					if (cooldown[i] > 0) {
						cooldown[i]--;
					}
				}
				if (fade == 0) {
					if (kidSpawnTime > 0) {
						kidSpawnTime--;
					} else {
						if (kids.size() < maxKids
								&& Misc.getRandomInt(kidSpawnTimeRandom) == 1) {
							kids.add(new Kid());
							kidSpawnTime = kidSpawnTimeMin;
						}
					}
					if (!gameover) {
						if (health <= 0
								|| protect > plantCount(PlantType.FLOWER)) {
							if (health <= 0) {
								play(SOUND_DIE);
							}
							keys[19] = false;
							gameover = true;
							won = level == 5;
							fade = 1;
							fadeType = 3;
						} else if (keys[19] || hasGoals()) {
							play(SOUND_DONE);
							keys[19] = false;
							gameover = true;
							won = true;
							fade = 1;
							fadeType = 3;
							// System.out.println("won");
						}
					}
					if (pickupIn > 0) {
						pickupIn--;
					}
					if (health <= 0) {
						health = 0;
					} else if (stunned > 0) {
						stunned--;
					} else {
						if (uproot == -1 && sow == -1) {
							Vector2D v = new Vector2D(0, 0);
							if (keys[0] || keys[12]) {
								v.y--;
							}
							if (keys[1] || keys[13]) {
								v.x--;
							}
							if (keys[2] || keys[14]) {
								v.y++;
							}
							if (keys[3] || keys[15]) {
								v.x++;
							}
							if (v.x != 0 || v.y != 0) {
								double rot = Misc.positionsToRotation(0, 0,
										v.x, v.y);
								double sx = Math.cos(rot) * 3d
										* (cola > 0 ? 2d : 1d);
								double sy = Math.sin(rot) * 3d
										* (cola > 0 ? 2d : 1d);
								double way = Math.sqrt(sx * sx + sy * sy);
								int n = (int) Math.ceil(way);
								sx /= (double) n;
								sy /= (double) n;
								way /= (double) n;
								GameObj o;
								int jC = objs.size();
								for (int i = 0; i < n; i++) {
									if (canGo(pos.x + sx, pos.y + sy)) {
										pos.x += sx;
										pos.y += sy;
										walked += way;
										rotation = rot;
									} else if (canGo(pos.x + sx, pos.y)) {
										pos.x += sx;
										walked += Math.abs(sx);
										rotation = rot;
									} else if (canGo(pos.x, pos.y + sy)) {
										pos.y += sy;
										walked += Math.abs(sy);
										rotation = rot;
									} else {
										break;
									}
									for (int j = 0; j < jC; j++) {
										o = objs.get(j);
										if (o.collides(pos)) {
											int h = o.canPickup();
											if (h == -2) { // cola
												cola = 6 * 25;
											} else if (h >= 0 && hand == -1
													&& pickupIn == 0) {
												hand = h;
												objs.remove(j);
												j--;
												jC--;
												break;
											}
										}
									}
								}
							}
							int x = (int) (pos.x / 50d);
							int y = (int) (pos.y / 50d);
							care += cola > 0 ? 2 : 1;
							if (care >= 25) {
								care = 0;
								if (plants[x][y] != null) {
									plants[x][y].heal();
								}
							}
							if (plants[x][y] != null) {
								if (plants[x][y].type == PlantType.STRAWBERRY) {
									int h = plants[x][y].tryHarvest(health);
									if (h == -2) {
										if (health < 10) {
											play(SOUND_OMNOM);
											health++;
										}
									}
								} else if (hand == -1 && pickupIn == 0) {
									int h = plants[x][y].tryHarvest(health);
									if (h != -1) {
										hand = h;
									}
								}
							}
							if (keys[16] || keys[25]) {
								if (hand >= 0) {
									double rot = Misc.positionsToRotation(
											(int) pos.x, (int) pos.y, mouse.x,
											mouse.y);
									play(SOUND_THROW);
									ObjType ot = ObjType.getByHand(hand);
									if (ot == ObjType.ROWAN) {
										double rot2;
										for (int i = 0; i < 5; i++) {
											rot2 = Misc
													.normalizeRotation(rot
															- 0.5d
															+ (0.8d * ((double) i) / 5d)
															+ Math.random()
															* 0.2d);
											objs.add(throwObj(true, pos.get(),
													ot, new Vector2D(pos.x
															+ Math.cos(rot2)
															* 700d, pos.y
															+ Math.sin(rot2)
															* 700d)));
										}
									} else {
										objs.add(throwObj(
												true,
												pos.get(),
												ot,
												new Vector2D(pos.x
														+ Math.cos(rot) * 700d,
														pos.y + Math.sin(rot)
																* 700d)));
									}
									thrown++;
									hand = -1;
								}
								keys[16] = false;
								keys[25] = false;
							}
							if (keys[17]) {
								if (hand >= 0) {
									GameObj o = new GameObj(pos.get(),
											Misc.normalizeRotation(rotation
													- Math.PI),
											ObjType.getByHand(hand));
									objs.add(o);
									hand = -1;
									pickupIn = 25;
								}
								keys[17] = false;
							}
							if (getSeed() != -1) {
								sow = 25;
							}
							if (keys[9] || keys[18]) {
								uproot = 25;
							}
						}
						int x = (int) (pos.x / 50d);
						int y = (int) (pos.y / 50d);
						if (sow > -1) {
							uproot = -1;
							if (sow == 25) {
								offhand = hand;
								hand = getSeed();
							}
							if (getSeed() == hand) {
								PlantType pt = PlantType.getBySeed(hand);
								if (allowed[pt.plantNr()]
										&& plants[x][y] == null
										&& cooldownAll == 0
										&& cooldown[pt.plantNr()] == 0) {
									sow -= cola > 0 ? 2 : 1;
									if (sow <= 0) {
										sow = -1;
										play(SOUND_SOW);
										plants[x][y] = new Plant(
												new Point(x, y), pt, false);
										planted++;
										cooldownAll = MAXCDALL;
										cooldown[pt.plantNr()] = pt
												.cooldownTime();
										hand = offhand;
										offhand = -1;
									}

								} else {
									sow = -1;
									hand = offhand;
									offhand = -1;
								}
							} else {
								hand = offhand;
								offhand = -1;
								sow = -1;
							}
						}
						if (uproot > -1) {
							sow = -1;
							if (keys[9] || keys[18]) {
								if (plants[x][y] == null) {
									uproot = -1;
								} else {
									uproot -= cola > 0 ? 2 : 1;
									if (uproot <= 0) {
										uproot = -1;
										plants[x][y] = null;
										play(SOUND_UPROOT);
									}
								}
							} else {
								uproot = -1;
							}
						}
					}
				}
			}
		}
		ds.repaint();
	}

	private void initLevel() {
		resetKeys();
		ingame = false;
		gameover = false;
		won = false;
		cooldownAll = 0;
		for (int i = 0; i < allowed.length; i++) {
			allowed[i] = level >= i;
			cooldown[i] = 0;
		}
		score = 0;
		maxKids = 10;
		kidSpawnTimeMin = 2 * 25;
		kidSpawnTimeRandom = 3 * 25;
		kidSpawnTime = 0;
		healed = 0;
		uproot = -1;
		sow = -1;
		care = 0;
		health = 10;
		cola = 0;
		pickupIn = 0;
		protect = 0;
		time = 0;
		timeNeeded = 0;
		kills = 0;
		killsNeeded = 0;
		tomatoesNeeded = 0;
		heart = 0;
		thrown = 0;
		planted = 0;
		destroyed = 0;
		damageTaken = 0;
		stunned = 0;
		walked = 0d;
		hand = -1;
		offhand = -1;
		plants = new Plant[12][8];
		objs.clear();
		kids.clear();
		pos = new Vector2D(200, 300);
		rotation = 1.5d * Math.PI;
		for (int x = 0; x < 12; x++) {
			for (int y = 0; y < 8; y++) {
				if (walk[x][y] && Misc.getRandomInt(2) == 0) {
					plants[x][y] = new Plant(new Point(x, y), PlantType.GRASS,
							true);
				} else {
					plants[x][y] = null;
				}
			}
		}
		switch (level) {
		case 0:
			maxKids = 4;
			kidSpawnTimeMin = 5 * 25;
			kidSpawnTimeRandom = 7 * 25;
			timeNeeded = 1 * 60 * 25;
			protect = 4;
			pos.x = 393;
			pos.y = 278;
			rotation = Math.PI * 1.25d;
			plants[7][5] = new Plant(new Point(7, 5), PlantType.FLOWER, true);
			plants[7][6] = new Plant(new Point(7, 6), PlantType.FLOWER, true);
			plants[8][5] = new Plant(new Point(8, 5), PlantType.FLOWER, true);
			plants[8][6] = new Plant(new Point(8, 6), PlantType.FLOWER, true);
			plants[6][5] = new Plant(new Point(6, 5), PlantType.FLOWER, true);
			plants[6][6] = new Plant(new Point(6, 6), PlantType.FLOWER, true);
			break;
		case 1:
			timeNeeded = 2 * 60 * 25;
			protect = 6;
			killsNeeded = 5;
			maxKids = 5;
			kidSpawnTimeMin = 5 * 25;
			kidSpawnTimeRandom = 6 * 25;
			pos.x = 360;
			pos.y = 277;
			rotation = Math.PI;
			plants[7][5] = new Plant(new Point(7, 5), PlantType.FLOWER, true);
			plants[7][6] = new Plant(new Point(7, 6), PlantType.FLOWER, true);
			plants[8][5] = new Plant(new Point(8, 5), PlantType.FLOWER, true);
			plants[8][6] = new Plant(new Point(8, 6), PlantType.FLOWER, true);
			plants[6][5] = new Plant(new Point(6, 5), PlantType.FLOWER, true);
			plants[6][6] = new Plant(new Point(6, 6), PlantType.FLOWER, true);
			break;
		case 2:
			maxKids = 7;
			kidSpawnTimeMin = 4 * 25;
			kidSpawnTimeRandom = 5 * 25;
			pos.x = 255;
			pos.y = 276;
			rotation = Math.PI * 0.50d;
			tomatoesNeeded = 5;
			killsNeeded = 10;
			break;
		case 3:
			maxKids = 8;
			kidSpawnTimeMin = 3 * 25;
			kidSpawnTimeRandom = 4 * 25;
			pos.x = 66;
			pos.y = 263;
			rotation = 0;
			timeNeeded = 3 * 60 * 25;
			killsNeeded = 25;
			break;
		case 4:
			pos.x = 176;
			pos.y = 286;
			rotation = Math.PI * 1.75d;
			timeNeeded = 5 * 60 * 25;
			protect = 5;
			plants[0][6] = new Plant(new Point(0, 6), PlantType.FLOWER, true);
			plants[1][6] = new Plant(new Point(1, 6), PlantType.FLOWER, true);
			plants[2][6] = new Plant(new Point(2, 6), PlantType.FLOWER, true);
			plants[3][6] = new Plant(new Point(3, 6), PlantType.FLOWER, true);
			plants[4][6] = new Plant(new Point(4, 6), PlantType.FLOWER, true);
			plants[5][6] = new Plant(new Point(5, 6), PlantType.FLOWER, true);
			plants[6][6] = new Plant(new Point(6, 6), PlantType.FLOWER, true);
			plants[7][6] = new Plant(new Point(7, 6), PlantType.FLOWER, true);
			plants[8][6] = new Plant(new Point(8, 6), PlantType.FLOWER, true);
			break;
		case 5:
			// endless survival
			pos.x = 120;
			pos.y = 274;
			rotation = Math.PI * 1.75d;
			protect = 4;
			plants[0][6] = new Plant(new Point(0, 6), PlantType.FLOWER, true);
			plants[1][6] = new Plant(new Point(1, 6), PlantType.FLOWER, true);
			plants[2][6] = new Plant(new Point(2, 6), PlantType.FLOWER, true);
			plants[3][6] = new Plant(new Point(3, 6), PlantType.FLOWER, true);
			plants[4][6] = new Plant(new Point(4, 6), PlantType.FLOWER, true);
			plants[5][6] = new Plant(new Point(5, 6), PlantType.FLOWER, true);
			plants[6][6] = new Plant(new Point(6, 6), PlantType.FLOWER, true);
			plants[7][6] = new Plant(new Point(7, 6), PlantType.FLOWER, true);
			plants[8][6] = new Plant(new Point(8, 6), PlantType.FLOWER, true);
			break;
		}
	}

	private void initSwing() {
		ds = new Drawscreen();
		window = new JFrame("Leaf me Alone Postcompo 1.2.1 by AyCe for LD22");
		window.setIconImage(icon);
		window.setResizable(false);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				//
			}

			public void focusLost(FocusEvent e) {
				resetKeys();
			}
		});
		Container content = window.getContentPane();
		content.setPreferredSize(new Dimension(600, 400));
		content.setLayout(null);
		content.add(ds);
		ds.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				mouse.x = e.getX();
				mouse.y = e.getY();
				if (fade == 0) {
					if (e.getButton() == MouseEvent.BUTTON1) {
						if (!keys2[16]) {
							keys[16] = true;
							keys2[16] = true;
						}
					} else if (e.getButton() == MouseEvent.BUTTON3) {
						if (ingame && !keys2[17]) {
							keys[17] = true;
							keys2[17] = true;
						}
					}
				}
			}

			public void mouseReleased(MouseEvent e) {
				mouse.x = e.getX();
				mouse.y = e.getY();
				if (e.getButton() == MouseEvent.BUTTON1) {
					keys2[16] = false;
				} else if (e.getButton() == MouseEvent.BUTTON3) {
					keys2[17] = false;
				}
			}
		});
		ds.addMouseMotionListener(new MouseMotionListener() {
			public void mouseDragged(MouseEvent e) {
				mouse.x = e.getX();
				mouse.y = e.getY();
			}

			public void mouseMoved(MouseEvent e) {
				mouse.x = e.getX();
				mouse.y = e.getY();
			}
		});
		window.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				int key = getKey(e.getKeyCode());
				if (key > -1 && !keys2[key]) {
					if (key == 19 && !e.isControlDown()) {
						return;
					}
					keys[key] = true;
					keys2[key] = true;
					switch (key) {
					case 10:
						if (ingame) {
							paused = !paused;
						}
						break;
					case 11:
						Misc.makeSS(ds);
						break;
					case 26:
						playMusic = !playMusic;
						if (loaded) {
							if (playMusic) {
								music.startLoop();
							} else {
								music.stopLoop();
							}
						}
						break;
					case 27:
						playSound = !playSound;
						break;
					}
				}
			}

			public void keyReleased(KeyEvent e) {
				int key = getKey(e.getKeyCode());
				if (key > -1) {
					keys[key] = false;
					keys2[key] = false;
				}
			}
		});
		window.pack();
		window.setLocationRelativeTo(null);
		window.setVisible(true);
		window.repaint();
		javax.swing.Timer t = new javax.swing.Timer(40, new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tick();
			}
		});
		t.start();
	}

	private class Drawscreen extends JPanel {
		private static final long serialVersionUID = 1L;

		public Drawscreen() {
			setBounds(0, 0, 600, 400);
		}

		public void paintComponent(Graphics gFake) {
			super.paintComponent(gFake);
			Graphics2D g = (Graphics2D) gFake;
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			if (level == -1) {
				if (loaded) {
					g.setColor(Color.BLACK);
					g.fillRect(0, 0, 600, 400);
					g.drawImage(logo, 0, 0, null);
					g.setFont(fontText);
					g.setColor(Color.WHITE);
					Misc.drawCenteredString(
							"You are a gardener doing his job.", 0, 100, 600,
							20, g);
					Misc.drawCenteredString("And you are alone. As always.", 0,
							120, 600, 20, g);
					Misc.drawCenteredString(
							"Move with WASD or arrows, aim with the mouse.", 0,
							160, 600, 20, g);
					Misc.drawCenteredString(
							"Click or use spacebar to throw objects.", 0, 180,
							600, 20, g);
					Misc.drawCenteredString("Right-click to drop objects.", 0,
							200, 600, 20, g);
					Misc.drawCenteredString(
							"Sow plants with 1-5 (NUM 1-5). (on cleared ground)",
							0, 220, 600, 20, g);
					Misc.drawCenteredString(
							"Stay some seconds on a plant to care it.", 0, 240,
							600, 20, g);
					Misc.drawCenteredString(
							"To uproot a plant (also grass/weed), hold E or NUM 0.",
							0, 260, 600, 20, g);
					Misc.drawCenteredString(
							"Walk over an object/plant to pick it(s fruits) up.",
							0, 280, 600, 20, g);
					Misc.drawCenteredString(
							"(If you have nothing in your hand (right bottom) already)",
							0, 300, 600, 20, g);
					Misc.drawCenteredString(
							"Be careful, there are kids around here!", 0, 320,
							600, 20, g);
					g.setColor(Color.YELLOW);
					Misc.drawCenteredString("Press spacebar to start!", 0, 340,
							600, 60, g);
				} else {
					g.setColor(Color.GRAY);
					g.fillRect(0, 0, 600, 400);
					g.setFont(fontQuote);
					g.setColor(Color.WHITE);
					Misc.drawShadowedCenteredString("Game is loading...", 0, 0,
							600, 400, g);

				}
			} else {
				if (ingame) {
					g.drawImage(mapimg, 0, 0, null);
					Plant p;
					for (int x = 0; x < 12; x++) {
						for (int y = 0; y < 8; y++) {
							p = plants[x][y];
							if (p != null) {
								p.render(g);
							}
						}
					}
					int oC = objs.size();
					for (int i = 0; i < oC; i++) {
						objs.get(i).render(g, false);
					}
					int gx = (int) (pos.x / 50d);
					int gy = (int) (pos.y / 50d);
					g.setColor(Color.DARK_GRAY);
					g.drawRect(gx * 50, gy * 50, 49, 49);
					if (stunned == 0 && health > 0) {
						g.setColor(Color.BLACK);
						g.fillOval(mouse.x - 6, mouse.y - 6, 12, 12);
						double rot = Misc.positionsToRotation((int) pos.x,
								(int) pos.y, mouse.x, mouse.y);
						g.drawLine((int) pos.x, (int) pos.y,
								(int) (pos.x + 600 * Math.cos(rot)),
								(int) (pos.y + 600 * Math.sin(rot)));
					}
					AffineTransform t = g.getTransform();
					g.rotate(rotation, pos.x, pos.y);
					if (stunned > 0 || health <= 0) {
						g.drawImage(gardenerStunned, (int) pos.x - 25,
								(int) pos.y - 25, null);
					} else {
						g.drawImage(legs[(int) ((walked % 40d) / 10d)],
								(int) pos.x - 25, (int) pos.y - 25, null);
						g.drawImage(gardener, (int) pos.x - 25,
								(int) pos.y - 25, null);
					}
					g.setTransform(t);
					int kC = kids.size();
					for (int i = 0; i < kC; i++) {
						kids.get(i).render(g);
					}
					for (int i = 0; i < oC; i++) {
						objs.get(i).render(g, true);
					}
					// ---------- UI --------------
					g.drawImage(uiimg, 0, 0, null);
					if (cola > 0) {
						g.drawImage(projectiles[2], 475, 275, null);
					}
					if (hand >= 0) {
						g.drawImage(handimgs[hand], 500, 300, null);
					}
					g.setColor(Color.BLACK);
					g.fillRect(565, 255, 20, 40);
					g.setColor(getHealthColor(health, 10));
					int h = (int) (36d * (((double) health) / 10d));
					g.fillRect(567, 293 - h, 16, h);
					if (uproot > -1) {
						g.setColor(Color.BLACK);
						g.fillRect(172, 187, 206, 20);
						g.setColor(Color.WHITE);
						g.fillRect(175, 190, 200 - uproot * 8, 14);
					}
					if (sow > -1) {
						g.setColor(Color.BLACK);
						g.fillRect(172, 187, 206, 20);
						g.setColor(Color.WHITE);
						g.fillRect(175, 190, 200 - sow * 8, 14);
					}
					g.setFont(fontText);
					g.setColor(Color.BLACK);
					Misc.drawVerticalCenteredString(formatTime(time)
							+ (timeNeeded > 0 ? " (" + formatTime(timeNeeded)
									+ ")" : "")
							+ " | Kids fended: "
							+ kills
							+ (killsNeeded > 0 ? " (" + killsNeeded + ")" : "")
							+ (tomatoesNeeded > 0 ? " ("
									+ plantCount(PlantType.TOMATOE) + "/"
									+ tomatoesNeeded + " Tomatoes)" : ""), 5,
							350, 50, g);
					double cd;
					int cdi;
					PlantType pt;
					for (int i = 0; i < 5; i++) {
						if (allowed[i]) {
							g.drawImage(ground[8 + i], 552, 50 * i + 2, 46, 46,
									null);
							pt = PlantType.getBySeed(i + 5);
							cdi = cooldown[pt.plantNr()];
							if (cooldownAll > cdi) {
								cd = ((double) cooldownAll)
										/ ((double) MAXCDALL);
							} else {
								cd = ((double) cdi)
										/ ((double) pt.cooldownTime());
							}
							if (cd > 0) {
								g.setColor(CDCOLOR);
								g.fillArc(554, 50 * i + 4, 42, 42, 90,
										(int) (360d * cd));
							}
						} else {
							g.setColor(Color.GRAY);
							g.fillRect(552, 50 * i + 2, 46, 46);
						}
					}
				} else {
					if (gameover) {
						g.setColor(Color.BLACK);
						g.fillRect(0, 0, 600, 400);
						g.setColor(Color.LIGHT_GRAY);
						g.setFont(fontLevel);
						Misc.drawCenteredString(level == 5 ? "Statistics"
								: "Level completed!", 0, 0, 600, 100, g);
						g.setFont(fontStats);
						g.setColor(Color.WHITE);
						g.drawString("Time:", 100, 125);
						g.drawString("Kids fended:", 100, 145);
						g.drawString("Throws:", 100, 165);
						g.drawString("Sowed:", 100, 185);
						g.drawString("Plants lost:", 100, 205);
						g.drawString("Damage taken:", 100, 225);
						g.drawString("Plants cared (HP):", 100, 245);
						g.drawString("Distance walked:", 100, 265);
						g.drawString("Score:", 100, 300);
						Misc.drawStringRight(formatTime(time), 500, 125, g);
						Misc.drawStringRight("" + kills, 500, 145, g);
						Misc.drawStringRight("" + thrown, 500, 165, g);
						Misc.drawStringRight("" + planted, 500, 185, g);
						Misc.drawStringRight("" + destroyed, 500, 205, g);
						Misc.drawStringRight("" + damageTaken, 500, 225, g);
						Misc.drawStringRight("" + healed, 500, 245, g);
						Misc.drawStringRight(formatDistance(walked), 500, 265,
								g);
						Misc.drawStringRight("" + score, 500, 300, g);
						g.setFont(fontText);
						g.setColor(Color.YELLOW);
						Misc.drawCenteredString("Press spacebar to continue",
								0, 300, 600, 100, g);
					} else {
						if (level == lastLevel && !successinfo) {
							g.setColor(Color.BLACK);
							g.fillRect(0, 0, 600, 400);
							g.drawImage(logo, 0, 0, null);
							g.drawImage(wonimg, 0, 100, null);
							g.setColor(Color.WHITE);
							g.setFont(fontText);
							Misc.drawCenteredString(
									"Congratulations, you won!", 0, 220, 600,
									20, g);
							Misc.drawCenteredString(
									"You successfully played through all levels!",
									0, 240, 600, 20, g);
							Misc.drawCenteredString("The game is over, but...",
									0, 260, 600, 20, g);
							Misc.drawCenteredString("There's an extra level!", 0,
									300, 600, 20, g);
							g.setColor(Color.YELLOW);
							Misc.drawCenteredString(
									"Press spacebar, if you are HARDCORE!!", 0,
									320, 600, 80, g);

						} else {
							g.setColor(Color.BLACK);
							g.fillRect(0, 0, 600, 400);
							g.setColor(Color.LIGHT_GRAY);
							g.setFont(fontText);
							Misc.drawCenteredString("Level " + (level + 1), 0,
									2, 600, 20, g);
							g.setFont(fontLevel);
							Misc.drawCenteredString(names[level], 0, 20, 600,
									40, g);
							g.setFont(fontQuote);
							Misc.drawCenteredString(quotes[level], 0, 60, 600,
									30, g);
							g.setColor(Color.LIGHT_GRAY);
							g.fillRect(10, 110, 580, 130);
							g.setColor(Color.BLACK);
							g.setFont(fontText);
							Misc.drawCenteredString(desc[level], 0, 120, 600,
									30, g);
							Misc.drawCenteredString(desc2[level], 0, 160, 600,
									30, g);
							Misc.drawCenteredString(desc3[level], 0, 200, 600,
									30, g);
							g.setColor(Color.WHITE);
							switch (level) {
							case 0:
								Misc.drawImage(projectiles[0], 10, 260, g);
								Misc.drawVerticalCenteredString(
										"Kids will throw stones at you. Don't get hit.",
										80, 260, 30, g);
								Misc.drawVerticalCenteredString(
										"Pick them up and throw them back!",
										80, 290, 30, g);
								Misc.drawImage(ground[1 + (flash > 0 ? 7 : 0)],
										10, 330, g);
								Misc.drawVerticalCenteredString(
										"Bushes will cover you and your plants.",
										80, 330, 30, g);
								Misc.drawVerticalCenteredString(
										"Watch the seed cooldown on the right!",
										80, 360, 30, g);
								break;
							case 1:
								Misc.drawImage(projectiles[1], 10, 260, g);
								Misc.drawVerticalCenteredString(
										"Dung will stun you for a moment.", 80,
										260, 30, g);
								Misc.drawVerticalCenteredString(
										"It helps plants to grow where it lands!",
										80, 290, 30, g);
								Misc.drawImage(ground[2 + (flash > 0 ? 7 : 0)],
										10, 330, g);
								Misc.drawVerticalCenteredString(
										"Strawberries provide a health source when ripe.",
										80, 330, 30, g);
								Misc.drawVerticalCenteredString(
										"Walk over them to regain health.", 80,
										360, 30, g);
								break;
							case 2:
								Misc.drawImage(projectiles[2], 10, 260, g);
								Misc.drawVerticalCenteredString(
										"Cola bottles give you temporary speed.",
										80, 260, 30, g);
								Misc.drawVerticalCenteredString(
										"Catch it, or it will break!", 80, 290,
										30, g);
								Misc.drawImage(ground[3 + (flash > 0 ? 7 : 0)],
										10, 330, g);
								Misc.drawVerticalCenteredString(
										"Tomatoes: Walk over them with nothing in your",
										80, 330, 30, g);
								Misc.drawVerticalCenteredString(
										"hand and throw them at those kiddies!",
										80, 360, 30, g);
								break;
							case 3:
								Misc.drawImage(projectiles[3], 10, 260, g);
								Misc.drawVerticalCenteredString(
										"Dodge arrows, they are dangerous.",
										80, 260, 30, g);
								Misc.drawVerticalCenteredString(
										"Throw them back, they are fast and damaging!",
										80, 290, 30, g);
								Misc.drawImage(ground[4 + (flash > 0 ? 7 : 0)],
										10, 330, g);
								Misc.drawVerticalCenteredString(
										"Rowan can poison them.", 80, 330, 30,
										g);
								Misc.drawVerticalCenteredString(
										"Many small berries will be thrown!",
										80, 360, 30, g);
								break;
							case 4:
								Misc.drawImage(ground[5 + (flash > 0 ? 7 : 0)],
										10, 330, g);
								Misc.drawVerticalCenteredString(
										"Pumpkins will do area damage to them.",
										80, 330, 30, g);
								Misc.drawVerticalCenteredString(
										"They hit whatever is in the way. ",
										80, 360, 30, g);
								break;
							case 5:
								Misc.drawCenteredString("Thanks for playing! :D", 10, 260, 580,
										130, g);
								break;
							}
						}
					}
				}
			}
			if (fade != 0) {
				g.setColor(new Color(0, 0, 0, Math.abs(fade) * 15));
				g.fillRect(0, 0, 600, 400);
			}
			if (paused) {
				g.setColor(PAUSEBG);
				g.fillRect(0, 0, 600, 400);
				g.setColor(Color.RED);
				g.setFont(fontLevel);
				Misc.drawShadowedCenteredString("Paused", 0, 0, 600, 50, g);
				g.setFont(fontText);
				Misc.drawShadowedCenteredString("Press P to unpause", 0, 50,
						600, 20, g);
				g.setColor(Color.BLACK);
				g.drawString("- Use WASD or arrow keys to move around", 20, 90);
				g.drawString("- Use E or NUM 0 to uproot a plant", 20, 120);
				g.drawString("- Use 1-5 or NUM 1-5 to sow a plant", 20, 150);
				g.drawString("- You can only sow on clear ground", 20, 180);
				g.drawString(
						"- If your plant is damaged, a hitpoint bar will show",
						20, 210);
				g.drawString("- Stay on the plant to heal it", 20, 240);
				g.drawString("- Use the mouse to aim your throws", 20, 270);
				g.drawString(
						"- Right bottom: Object you are currently holding", 20,
						300);
				g.drawString("- Throw it by clicking or pressing spacebar", 20,
						330);
				g.drawString("- Right-click to drop whatever you are holding",
						20, 360);
				g.drawString(
						"- Your health is shown on the right, goals at the bottom",
						20, 390);
			}
		}
	}

	private int calculateScore() {
		return time / 25 + planted * 3 + healed - destroyed * 4 + kills * 3
				+ thrown + damageTaken * 2 + plantCount(PlantType.FLOWER) * 35;
	}

	public enum ObjType {
		STONE, DUNG, COLA, ARROW, TOMATOE, ROWAN, PUMPKIN;
		public static ObjType getByHand(int hand) {
			switch (hand) {
			case 0:
				return STONE;
			case 1:
				return ARROW;
			case 2:
				return TOMATOE;
			case 3:
				return ROWAN;
			case 4:
				return PUMPKIN;
			default:
				return STONE;
			}
		}

		public int getGFX() {
			switch (this) {
			case STONE:
				return 0;
			case DUNG:
				return 1;
			case COLA:
				return 2;
			case ARROW:
				return 3;
			case TOMATOE:
				return 4;
			case ROWAN:
				return 5;
			case PUMPKIN:
				return 6;
			default:
				return 0;
			}
		}

		public double getSize() {
			switch (this) {
			case STONE:
				return 9;
			case DUNG:
				return 7;
			case COLA:
				return 13;
			case ARROW:
				return 7;
			case TOMATOE:
				return 9;
			case ROWAN:
				return 4;
			case PUMPKIN:
				return 20;
			default:
				return 0;
			}
		}

		public int getDamage() {
			switch (this) {
			case STONE:
				return 2;
			case DUNG:
				return 1;
			case COLA:
				return 3;
			case ARROW:
				return 4;
			case TOMATOE:
				return 2;
			case ROWAN:
				return 0;
			case PUMPKIN:
				return 5;
			default:
				return 0;
			}
		}

		public boolean stuns() {
			switch (this) {
			case DUNG:
			case TOMATOE:
				return true;
			default:
				return false;
			}
		}

		public boolean poisons() {
			switch (this) {
			case ROWAN:
				return true;
			default:
				return false;
			}
		}

		public double getSpeed() {
			switch (this) {
			case STONE:
				return 4d;
			case DUNG:
				return 3d;
			case COLA:
				return 4d;
			case ARROW:
				return 8d;
			case TOMATOE:
				return 6d;
			case ROWAN:
				return 5d;
			case PUMPKIN:
				return 5d;
			default:
				return 1d;
			}
		}
	}

	public enum PlantType {
		GRASS, FLOWER, BUSH, STRAWBERRY, TOMATOE, ROWAN, PUMPKIN;
		public int growtime() {
			switch (this) {
			case GRASS:
				return 25;
			case FLOWER:
				return 20;
			case BUSH:
				return 50;
			case STRAWBERRY:
				return 75;
			case TOMATOE:
				return 100;
			case ROWAN:
				return 60;
			case PUMPKIN:
				return 150;
			default:
				return 0;
			}
		}

		public int ripetime() {
			switch (this) {
			case GRASS:
				return 1;
			case FLOWER:
				return 1;
			case BUSH:
				return 1;
			case STRAWBERRY:
				return 7 * 25;
			case TOMATOE:
				return 5 * 25;
			case ROWAN:
				return 30 * 25;
			case PUMPKIN:
				return 20 * 25;
			default:
				return 1;
			}
		}

		public int plantNr() {
			switch (this) {
			case BUSH:
				return 0;
			case STRAWBERRY:
				return 1;
			case TOMATOE:
				return 2;
			case ROWAN:
				return 3;
			case PUMPKIN:
				return 4;
			default:
				return -1;
			}
		}

		public int cooldownTime() {
			switch (this) {
			case BUSH:
				return 4 * 25;
			case STRAWBERRY:
				return 10 * 25;
			case TOMATOE:
				return 20 * 25;
			case ROWAN:
				return 30 * 25;
			case PUMPKIN:
				return 40 * 25;
			default:
				return 0;
			}
		}

		public int getHP() {
			switch (this) {
			case GRASS:
				return 4;
			case FLOWER:
				return 5;
			case BUSH:
				return 10;
			case STRAWBERRY:
				return 3;
			case TOMATOE:
				return 4;
			case ROWAN:
				return 6;
			case PUMPKIN:
				return 5;
			default:
				return 1;
			}
		}

		public int getGFX() {
			switch (this) {
			case GRASS:
				return 0;
			case FLOWER:
				return 6;
			case BUSH:
				return 1;
			case STRAWBERRY:
				return 2;
			case TOMATOE:
				return 3;
			case ROWAN:
				return 4;
			case PUMPKIN:
				return 5;
			default:
				return 0;
			}
		}

		public int getFruit() {
			switch (this) {
			case STRAWBERRY:
				return -2; // special
			case TOMATOE:
				return 2;
			case ROWAN:
				return 3;
			case PUMPKIN:
				return 4;
			default:
				return -1;
			}
		}

		public boolean ripes() {
			switch (this) {
			case GRASS:
			case FLOWER:
			case BUSH:
				return false;
			default:
				return true;
			}
		}

		public static PlantType getBySeed(int seed) {
			switch (seed) {
			case 5:
				return BUSH;
			case 6:
				return STRAWBERRY;
			case 7:
				return TOMATOE;
			case 8:
				return ROWAN;
			case 9:
				return PUMPKIN;
			default:
				return GRASS;
			}
		}

		public static PlantType getRandom() {
			if(Misc.getRandomInt(2)==0) {
				return GRASS;
			}
			switch (Misc.getRandomInt(7)) {
			case 0:
				return BUSH;
			case 1:
				return STRAWBERRY;
			case 2:
				return TOMATOE;
			case 3:
				return ROWAN;
			case 4:
				return PUMPKIN;
			case 5:
				return GRASS;
			case 6:
				return FLOWER;
			default:
				return GRASS;
			}
		}
	}

	private class Plant {
		private PlantType type;
		private Point p;
		private int grow;
		private int ripe;
		private int hp;
		private double rot;
		private static final double MAXROT = 40;

		public Plant(Point p, PlantType type, boolean grown) {
			this.p = p;
			this.type = type;
			this.grow = grown ? 0 : type.growtime();
			ripe = type.ripetime();
			if (!type.ripes() && Misc.getRandomInt(2) == 0) {
				ripe = 0;
			}
			hp = type.getHP();
			rot = Math.random() * MAXROT;
		}

		public void render(Graphics2D g) {
			int gfx = type.getGFX();
			int x = p.x * 50;
			int y = p.y * 50;
			if (grow == 0) {
				g.drawImage(ground[gfx + (ripe == 0 ? 7 : 0)], x, y, null);
			} else {
				int shift = (int) ((((double) grow) / ((double) type.growtime())) * 50d);
				g.drawImage(ground[gfx + (ripe == 0 ? 7 : 0)], x + shift / 2, y
						+ shift / 2, 50 - shift, 50 - shift, null);
			}
			if (type.ripes() && ripe == 0) {
				double rotation = Math.PI * 2d * (rot / MAXROT);
				AffineTransform t = g.getTransform();
				g.rotate(rotation, x + 25, y + 25);
				g.drawImage(ready, x, y, null);
				g.setTransform(t);
			}
			if (damaged() && type != PlantType.GRASS) {
				int f = (int) (30d * ((double) hp) / ((double) type.getHP()));
				g.setColor(Color.BLACK);
				g.fillRect(x + 8, y + 18, 34, 14);
				g.setColor(getHealthColor(hp, type.getHP()));
				g.fillRect(x + 10, y + 20, f, 10);
			}
		}

		public void damage(int dmg) {
			hp -= dmg;
			play(SOUND_HITPLANT);
			if (hp <= 0) {
				hp = 0;
				if (type != PlantType.GRASS) {
					destroyed++;
				}
				play(SOUND_DESTROYED);
				plants[p.x][p.y] = null;
			}
		}

		public void tick() {
			if (grow == 0) {
				if (type.ripes()) {
					if (ripe > 0) {
						ripe--;
						if (ripe == 0) {
							play(SOUND_RIPE);
						}
					} else {
						rot++;
						if (rot >= MAXROT) {
							rot = 0d;
						}
					}
				}
			} else {
				grow--;
			}
		}

		public int tryHarvest(int myhp) {
			if (type.ripes() && grow == 0 && ripe == 0) {
				if (type != PlantType.STRAWBERRY || myhp < 10) {
					ripe = type.ripetime();
					return type.getFruit();
				}
			}
			return -1;
		}

		public boolean damaged() {
			return hp < type.getHP();
		}

		public void heal() {
			if (type != PlantType.GRASS && hp < type.getHP()) {
				hp++;
				healed++;
			}
		}
	}

	private boolean inMap(int x, int y) {
		return x >= 0 && x < 12 && y >= 0 && y < 8;
	}

	private GameObj throwObj(boolean player, Vector2D pos, ObjType type,
			Vector2D tar) {
		GameObj o = new GameObj(pos, 0d, type);
		o.player = player;
		o.start = pos.get();
		o.tar = tar;
		o.numSteps = pos.dist(tar) / type.getSpeed();
		return o;
	}

	private class GameObj {
		private Vector2D pos;
		private double rotation;
		private double rotVelo;
		private ObjType type;
		private Vector2D tar;
		private Vector2D start;
		private double step;
		private double numSteps;
		private int size;
		private boolean player;
		private int disappear, myFade;

		public GameObj(Vector2D pos, double rot, ObjType type) {
			this.pos = pos.get();
			this.rotation = rot;
			this.type = type;
			rotVelo = Math.random();
			player = false;
			start = null;
			tar = null;
			step = 0;
			numSteps = 0;
			size = 0;
			disappear = 25 * 20;
			myFade = 25;
		}

		public void render(Graphics2D g, boolean flying) {
			if ((flying && tar != null) || (!flying && tar == null)) {
				int gfx = type.getGFX();
				AffineTransform t = g.getTransform();
				Composite c = g.getComposite();
				if (myFade < 25) {
					g.setComposite(AlphaComposite.getInstance(
							AlphaComposite.SRC_OVER, ((float) myFade) / 25f));
				}
				g.rotate(rotation, pos.x, pos.y);
				g.drawImage(projectiles[gfx], (int) pos.x - 25 - size / 2,
						(int) pos.y - 25 - size / 2, 50 + size, 50 + size, null);
				g.setTransform(t);
				g.setComposite(c);
			}
		}

		public boolean exists() {
			return myFade > 0 && !Misc.isOutOfMap(pos, true);
		}

		public boolean collides(Vector2D atPos) {
			return disappear > 0 && atPos.dist(pos) <= 15d;
		}

		public int canPickup() {
			if (disappear <= 0) {
				return -1;
			}
			if (type == ObjType.COLA) {
				return -2;
			} else if (tar == null) {
				switch (type) {
				case STONE:
					return 0;
				case ARROW:
					return 1;
				case TOMATOE:
					return 2;
				case ROWAN:
					return 3;
				case PUMPKIN:
					return 4;
				default:
					return -1;
				}
			} else {
				return -1;
			}
		}

		public void tick() {
			if (disappear > 0) {
				if (tar != null) {
					rotation = type == ObjType.ARROW ? Misc
							.positionsToRotation(start.x, start.y, tar.x, tar.y)
							: Misc.normalizeRotation(rotation + rotVelo);
					step++;
					if (step >= numSteps) {
						boolean hitground = type == ObjType.STONE
								|| type == ObjType.ARROW;
						pos = tar;
						tar = null;
						start = null;
						step = 0;
						//size = 0;
						numSteps = 0;
						// if (type == ObjType.COLA) {
						// broken = true;
						// if (pos.dist(inst.pos) <= 20d + type.getSize()) {
						// hitground = false;
						// cola = 5 * 25;
						// play(SOUND_COLA);
						// } else {
						// play(SOUND_KLIRR);
						// }
						// }
						if (pos.dist(inst.pos) <= 20d + type.getSize()) {
							damage(type.getDamage(), type.stuns());
							hitground = false;
						}
						int iC = kids.size();
						Kid k;
						for (int i = 0; i < iC; i++) {
							k = kids.get(i);
							if (k.collides(pos, type.getSize())) {
								k.damage(type.getDamage(), type);
								disappear = 0;
								hitground = false;
							}
						}
						int x = (int) (pos.x / 50d);
						int y = (int) (pos.y / 50d);
						if (inMap(x, y)) {
							Plant p = plants[x][y];
							if (p == null) {
								if (walk[x][y] && type == ObjType.DUNG
										&& Misc.getRandomInt(2) == 0) {
									plants[x][y] = new Plant(new Point(x, y),
											PlantType.getRandom(), false);
									play(SOUND_SOW);
								}
							} else {
								hitground = false;
								if (type == ObjType.DUNG) {
									if (p.grow > 0) {
										p.grow = 1;
									} else {
										if (p.hp < p.type.getHP()) {
											p.hp = p.type.getHP();
										} else if (p.type.ripes() && p.ripe > 0) {
											p.ripe = 1;
										}
									}
								} else {
									p.damage(type.getDamage());
								}
							}
						}
						if (hitground) {
							play(SOUND_HITGROUND);
						}
						// things that can't be thrown without breaking
						switch (type) {
						case DUNG:
							play(SOUND_FLATSCH);
							disappear = 0;
							break;
						case COLA:
							play(SOUND_KLIRR);
							disappear = 0;
							break;
						case TOMATOE:
							play(SOUND_FLATSCH);
							disappear = 0;
							break;
						case ROWAN:
							// (some sound...)
							disappear = 0;
							break;
						case PUMPKIN:
							play(SOUND_FLATSCH);
							disappear = 0;
							break;
						default:
							break;
						}
					} else {
						double q = step / numSteps;
						double rot = Misc.positionsToRotation(start.x, start.y,
								tar.x, tar.y);
						double dist = start.dist(tar);
						double sx = Math.cos(rot) * q * dist;
						double sy = Math.sin(rot) * q * dist;
						pos = start.add(sx, sy);
						size = (int) (20 * Math.sin(q * Math.PI));
						if (player) {
							int iC = kids.size();
							Kid k;
							for (int i = 0; i < iC; i++) {
								k = kids.get(i);
								if (k.collides(pos, type.getSize())) {
									k.damage(type.getDamage(), type);
									if (type != ObjType.PUMPKIN) {
										if (type == ObjType.TOMATOE) {
											play(SOUND_FLATSCH);
										}
										disappear = 0;
									}
								}
							}
						} else {
							if (type == ObjType.COLA) {
								if (pos.dist(inst.pos) <= 20d) {
									disappear = 0;
									cola = 5 * 25;
									play(SOUND_COLA);
								}
							} else if (type != ObjType.DUNG) {
								int px = (int) (pos.x / 50d);
								int py = (int) (pos.y / 50d);
								if (inMap(px, py)) {
									Plant p = plants[px][py];
									if (p != null && p.grow == 0
											&& p.type == PlantType.BUSH) {
										numSteps = 1;
										step = 1;
										double r = Misc.positionsToRotation(
												start.x, start.y, tar.x, tar.y);
										start = pos.get();
										tar = start.get();
										tar.move(r, 1d);
									}
								}
							}
						}
					}
				} else {
					disappear--;
					if(disappear < 0) {
						disappear = 0;
					}
				}
			} else {
				disappear = 0;
				myFade--;
				if (myFade <= 0) {
					myFade = 0;
				}
			}
		}
	}

	private class Kid {
		private Vector2D pos, tar;
		private double rotation;
		private boolean lastTar, exists, poisoned, killed;
		private int reload;
		private int type;
		private int hp;
		private int stunned;
		private int poisonTick;
		private int nextHit;

		public Kid() {
			pos = new Vector2D(-50 + Misc.getRandomInt(700), -50);
			hp = doHP();
			nextHit = 0;
			lastTar = false;
			killed = false;
			poisonTick = 0;
			poisoned = false;
			stunned = 0;
			exists = true;
			type = Misc.getRandomInt(6);
			tar = new Vector2D(0, 0);
			newTarget();
			rotation = Misc.positionsToRotation(pos.x, pos.y, tar.x, tar.y);
			reload();
		}

		private int doHP() {
			switch (level) {
			case 0:
				return 1;
			case 1:
				return 1 + Misc.getRandomInt(2);
			case 2:
				return 2;
			case 3:
				return 2 + Misc.getRandomInt(2);
			default:
				return 2 + Misc.getRandomInt(3);
			}
		}

		private void reload() {
			reload = 25 * 5 + Misc.getRandomInt(25 * 4);
		}

		public void damage(int dmg, ObjType type) {
			boolean poison = false;
			boolean stun = false;
			if (type != null) {
				stun = type.stuns();
				poison = type.poisons();
			}
			if (stun) {
				stunned = 3 * 25;
			}
			if (poison) {
				poisoned = true;
			}
			if (nextHit == 0 || type != ObjType.PUMPKIN) {
				play(SOUND_HITMARKER);
			}
			if (nextHit > 0) {
				return;
			}
			nextHit = 15;
			hp -= dmg;
			if (hp <= 0) {
				hp = 0;
				if (!killed) {
					kills++;
					killed = true;
				}
			}
		}

		public void tick() {
			if (poisoned) {
				poisonTick--;
				if (poisonTick <= 0) {
					poisonTick = 50;
					nextHit = 0;
					damage(1, null);
				}
			}
			if (stunned > 0) {
				stunned--;
			}
			if (nextHit > 0) {
				nextHit--;
			}
			if (stunned == 0) {
				if (reload > 0) {
					reload--;
				} else {
					if (hp > 0) {
						Vector2D throwtar = new Vector2D(-1, -1);
						if (Misc.getRandomInt(2) == 0) {
							// random
							do {
								throwtar.x = Misc.getRandomInt(550);
								throwtar.y = 100 + Misc.getRandomInt(250);
								if (canGo(throwtar.x, throwtar.y)) {
									break;
								}
							} while (true);
						} else {
							throwtar = inst.pos.get();
							if (Misc.getRandomInt(2) == 0) {
								// plant (if none, then gardener)
								java.util.List<Plant> pp = new ArrayList<Plant>();
								Plant p;
								for (int x = 0; x < 12; x++) {
									for (int y = 0; y < 8; y++) {
										p = plants[x][y];
										if (p != null
												&& p.type != PlantType.GRASS) {
											if (p.type == PlantType.FLOWER) {
												pp.add(p);
												pp.add(p);
											}
											pp.add(p);
										}
									}
								}
								int iC = pp.size();
								if (iC > 0) {
									Point point = pp.get(Misc.getRandomInt(iC)).p;
									throwtar.x = point.x * 50d + 25d;
									throwtar.y = point.y * 50d + 25d;
								}
							}
							throwtar.x = throwtar.x - 30d + Math.random() * 60d;
							throwtar.y = throwtar.y - 30d + Math.random() * 60d;
						}
						GameObj o = throwObj(false, pos.get(),
								randomThrowObj(), throwtar);
						play(SOUND_THROW);
						objs.add(o);
						reload();
					}
				}
				if (pos.dist(tar) <= 2d) {
					if (lastTar) {
						exists = false;
					} else {
						newTarget();
					}
				} else {
					pos.move(rotation, 2d);
				}
				rotation = Misc.positionsToRotation(pos.x, pos.y, tar.x, tar.y);
			}
		}

		private boolean collides(Vector2D atPos, double d) {
			return atPos.dist(pos) <= 10d + d;
		}

		private void newTarget() {
			if (hp > 0) {
				tar.x = Misc.getRandomInt(550);
				tar.y = Misc.getRandomInt(40);
			} else {
				lastTar = true;
				tar.x = -50 + Misc.getRandomInt(700);
				tar.y = -50;
			}
		}

		private ObjType randomThrowObj() {
			switch (level) {
			case 0:
				return ObjType.STONE;
			case 1:
				if (Misc.getRandomInt(4) == 0) {
					return ObjType.DUNG;
				}
				return ObjType.STONE;
			case 2:
				if (Misc.getRandomInt(4) == 0) {
					if (Misc.getRandomInt(3) == 0) {
						return ObjType.COLA;
					} else {
						return ObjType.DUNG;
					}
				}
				return ObjType.STONE;
			default:
				if (Misc.getRandomInt(3) == 0) {
					if (Misc.getRandomInt(3) == 0) {
						if (Misc.getRandomInt(3) == 0) {
							return ObjType.ARROW;
						}
						return ObjType.COLA;
					}
					return ObjType.DUNG;
				}
				return ObjType.STONE;
			}
		}

		public void render(Graphics2D g) {
			AffineTransform t = g.getTransform();
			g.rotate(rotation, pos.x, pos.y);
			g.drawImage(kidimgs[type], (int) pos.x - 25, (int) pos.y - 25, null);
			g.setTransform(t);
			if (poisoned) {
				g.setColor(POISONCOLOR);
				g.fillOval((int) pos.x - 10, (int) pos.y - 10, 20, 20);
			}
			if (nextHit > 0) {
				g.setColor(HITCOLOR);
				g.fillOval((int) pos.x - 10, (int) pos.y - 10, 20, 20);
			}
		}

		public boolean exists() {
			return exists;
		}
	}
}
