package com.iosoftware.ld22lma;

public class Vector2D {
	public double x,y;
	public Vector2D(double x, double y) {
		this.x = x;
		this.y = y;
	}
	public Vector2D add(double x, double y) {
		return add(new Vector2D(x, y));
	}
	public Vector2D add(Vector2D v) {
		return new Vector2D(x+v.x, y+v.y);
	}
	public Vector2D get() {
		return new Vector2D(x, y);
	}
	public double dist(Vector2D v) {
		double sx = x-v.x;
		double sy = y-v.y;
		return Math.sqrt(sx*sx + sy*sy);
	}
	public void move(double rot, double a) {
		x += Math.cos(rot)*a;
		y += Math.sin(rot)*a;
	}
}
